package sh.tablet.xposed.audiocapturehook.hook

import com.highcapable.yukihookapi.annotation.xposed.InjectYukiHookWithXposed
import com.highcapable.yukihookapi.hook.core.api.priority.YukiHookPriority
import com.highcapable.yukihookapi.hook.factory.configs
import com.highcapable.yukihookapi.hook.factory.encase
import com.highcapable.yukihookapi.hook.factory.method
import com.highcapable.yukihookapi.hook.log.YLog
import com.highcapable.yukihookapi.hook.xposed.proxy.IYukiHookXposedInit
import sh.tablet.xposed.audiocapturehook.application.MainApplication

@InjectYukiHookWithXposed
class HookEntry : IYukiHookXposedInit {

    override fun onInit() = configs {
        debugLog {
            tag = MainApplication.TAG
            isEnable = true
        }
    }
    val mName = "isAllowAudioPlaybackCapture"
    override fun onHook() = encase {
        loadSystem {
            val cls = "com.android.internal.pm.parsing.pkg.PackageImpl".toClass()
            cls.method {
                name = mName
            }.hook(YukiHookPriority.HIGHEST) {
                replaceToTrue()
                YLog.debug("successfully replaced ${cls.name}#$mName :)")
            }
        }
    }

}